unit Unit1;
{ logigram3 puzzel oplossing
--------------------------------
  logigram:
---------------------------------------------------------------------------
5 personen kopen elk een artikel voor een bepaald bedrag en betalen in
maandelijkse termijnen.

personen : Boy,Frankie,Marleen,Shirley,Sylvester
artikelen: CV-ketel,open haard,computer,televisie,home cinema set
bedragen : 2500,2700,3000,3300,3600
termijnen: 4,5,6,8,9

gegevens
1) Iemand betaalt 500 per maand gedurende 5 maanden
2) Sylvester koopt geen open haard en betaalt in 4 termijnen.
   De open haard kost 3600.
3) Shirley koopt de TV
4) de home cinema set wordt niet in 9 termijnen betaald
5) Boy's bedrag was niet 3000 en ook niet 3600
6) Frankie kocht geen CV ketel en betaalde 2700 maar niet in 8 termijnen
7) De CV ketel werd in 6 termijnen betaald

Wie kocht welk artikel tegen welke prijs en afschrijvingstermijnen?

Uitgangspunt
----------------------------------------------------------------------------
rij |                      kolommen
----------------------------------------------------------------------------
    | 0              1                2               3
    | persoon        artikel          bedrag          termijnen
----------------------------------------------------------------------------
0     Boy            CV ketel         2500            4
1     Frankie        open haard       2700            5
2     Marleen        computer         3000            6
3     Shirley        televisie        3300            8
4     Sylvester      home cinema set  3600            9

Bij het zoekem maar oplossingen blijven de personen in kolom 0
op hun plaats staan. Het nummer van de rij is gelijk aan de persoon.
De rijen in kolommen 1 t/m 3 verwisselen echter, tot een combinatie
is gevonden zonder conflicten.

Het programma gebruikt niet de omschrijvingen maar het rijnummer.
Dus de CV ketel = 0, open haard = 1, computer = 2, tv = 3, home cinema set = 4.
Hetzelfde geldt voor de kolommen 2 en 3.
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, Buttons, shellapi, ExtCtrls;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    StaticText1: TStaticText;
    StringGrid1: TStringGrid;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

type Tstring5 =  array[0..4] of string;
     TItem    = record
                  rij : byte;           //plaats in de tabel hierboven
                  kolom : byte;
                 end;
     TgameStatus = (gsBegin,gsZoeken,gsOplossing,gsEinde);

const Spersonen   : Tstring5 =          
                   ('Boy','Frankie','Marleen','Shirley','Sylvester');
      SArtikel    : Tstring5 =
                   ('CVketel','openhaard','computer','televisie','homecinemaset');
      SBedrag     : Tstring5 =
                   ('2500','2700','3000','3300','3600');
      STermijn    : Tstring5 =
                   ('4','5','6','8','9');

      SHeader     : Tstring5 =
                    ('persoon','artikel','prijs','termijnen','');

      cvketel       : TItem = (rij:0; kolom:1);      //plaats in de tabel
      openhaard     : TItem = (rij:1; kolom:1);
      computer      : TItem = (rij:2; kolom:1);
      televisie     : TItem = (rij:3; kolom:1);
      homecinemaset : TItem = (rij:4; kolom:1);
      E2500         : TItem = (rij:0; kolom:2);
      E2700         : TItem = (rij:1; kolom:2);
      E3000         : TItem = (rij:2; kolom:2);
      E3300         : TItem = (rij:3; kolom:2);
      E3600         : TItem = (rij:4; kolom:2);
      Termijn4      : TItem = (rij:0; kolom:3);
      Termijn5      : TItem = (rij:1; kolom:3);
      Termijn6      : TItem = (rij:2; kolom:3);
      Termijn8      : TItem = (rij:3; kolom:3);
      Termijn9      : TItem = (rij:4; kolom:3);

      Boy       = 0;  //persoon = rij 
      Frankie   = 1;
      Marleen   = 2;
      Shirley   = 3;
      Sylvester = 4;

var pCounter    : array[1..3] of byte;       //permutatie van de kolom
    permutatie  : array[0..4,0..119] of byte;//elementen op volgorde
    Xpermutatie : array[0..4,0..119] of byte;//plaats van element in kolom
    oplossing   : byte;                      //nummer van de oplossing
    gamestatus  : TGamestatus;

procedure maakpermutaties;
//maak alle permutaties in array permuts[0..4,0..119]
const delers : array[0..3] of byte = (24,6,2,1);
var i,j,k,rest,quot : byte;
    pel : array[0..4] of byte; //pel : permutatie van elementen 01234
begin
 for j := 0 to 119 do
  begin
   for i := 0 to 4 do pel[i] := i;   //set permutatie 0 = 01234
   rest := j;
   for i := 0 to 3 do
    begin                            //maak permutatie j
     quot := rest div delers[i];
     rest:= rest mod delers[i];
     permutatie[i,j] := pel[quot];   //item op zijn plaats in kolom
     Xpermutatie[pel[quot],j] := i;  //plaats van item in kolom
     for k := quot to 3 do pel[k] := pel[k+1]; //shift elements down
     pel[4] := 0;
    end;
   permutatie[4,j] := pel[0];        //overblijvend item
   Xpermutatie[pel[0],j] := 4;       //plaats item in de kolom
  end;//for j
end;

procedure setCells;
var i,j,k : byte;
begin
 k := 0;
 with form1.stringgrid1 do
  begin
   j := 0;
   for i := 0 to 3 do cells[i,j] := SHeader[i];
   for i := 0 to 3 do        //kolommen
    begin
     if i <> 0 then k := pCounter[i];
     for j := 0 to 4 do     //rijen
     case i of
      0 : cells[i,j+1] := Spersonen[j];
      1 : cells[i,j+1] := SArtikel[permutatie[j,k]];
      2 : cells[i,j+1] := SBedrag[permutatie[j,k]];
      3 : cells[i,j+1] := STermijn[permutatie[j,k]];
     end;//case
    end;
  end;//with
end;

procedure ZetBeginstand;
var i : byte;
begin
 for i := 1 to 3 do pCounter[i] := 0;
 setCells;
 form1.statictext1.caption := 'beginstand';
 oplossing := 0;
 gamestatus := gsBegin;
end;

function persoon(a : TItem) : byte;
//bepaal persoon (oftewel de rij) van activiteit a
var kolom,rij,k : byte;
begin
 kolom := a.kolom;
 rij := a.rij;
 k := pCounter[kolom];
 result := Xpermutatie[rij,k];
end;

function checkOK : boolean;
//test of aan voorwaarden is voldaan
begin
 result := (persoon(E2500) = persoon(termijn5))              and     //1
           (Sylvester <> persoon(openhaard))                 and     //2a
           (Sylvester = persoon(termijn4))                   and     //2b
           (persoon(openhaard) = persoon(E3600))             and     //2c 
           (Shirley = persoon(televisie))                    and     //3
           (persoon(homecinemaset) <> persoon(termijn9))     and     //4
           (Boy <> persoon(E3000))                           and     //5a
           (Boy <> persoon(E3600))                           and     //5b
           (Frankie  <> persoon(CVketel))                    and     //6a
           (Frankie = persoon(E2700))                        and     //6b
           (Frankie <> persoon(termijn8))                    and     //6c
           (persoon(cvketel) = persoon(termijn6));                   //6d
end;

procedure TForm1.FormCreate(Sender: TObject);
//delphi roept deze procedure aan bij opstarten
begin
 maakpermutaties;
 ZetBeginstand;
end;

function Increment : boolean;
//verhoog de teller Pcounter[1..3]
//carry = overdracht, verhogen volgende positie
var carry : boolean;
    i : byte;
begin
  carry := true;
  for i := 1 to 3 do
   begin
    if carry then inc(pCounter[i]);
    if pCounter[i] = 120 then pCounter[i] := 0
    else carry := false;
   end;//for
 result := carry;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
//aanroep bij klikken op knop "oplossen"
//zoeken naar oplossingen
begin
 case gameStatus of
  gsBegin     : gamestatus := gsZoeken;
  gsZoeken    : exit;
  gsOplossing : if increment then zetBeginstand
                 else gameStatus := gsZoeken;
  gsEinde     : zetBeginstand;
 end;//case
 if gamestatus <> gsZoeken then exit;
//
 statictext1.caption := 'computer zoekt...';
 repeat
  if checkOK then gamestatus := gsOplossing
   else if increment then gamestatus := gsEinde;
 until (gamestatus <> gsZoeken);
 case gameStatus of
  gsEinde     : statictext1.caption := 'geen oplossing';
  gsOplossing : begin
                 inc(oplossing);
                 statictext1.caption:='oplossing gevonden'+' : '+inttostr(oplossing);
                 setCells;
                end;
 end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
//aanroep bij klikken op knop "beginstand" 
begin
 Zetbeginstand;
end;

procedure TForm1.Image1Click(Sender: TObject);
//davdata website link
begin
 ShellExecute(0,'open','http://www.davdata.nl', nil, nil, SW_SHOWNORMAL);
end;

end.

